<?
$_startTime = getmicrotime();

include "config.php";


reset($_GET);
$permit = array("path", "file", "operate", "mode");

foreach($_GET as $key => $val)
	if(is_numeric($key) || !in_array($key, $permit))
		continue;
	else
		$$key = $val;


if($path)
	$path = str_replace("/..", "", $path);


if($file && !check_ext($file))
	 error("̿   ȮԴϴ.");
elseif($path && !is_dir($root_path.$path))
	 error("   丮Դϴ.");


if($operate == "down")
	downFile($path, $file);
elseif($operate == "view")
	viewFile($path, $file);
elseif($operate == "photo")
	viewPhoto($path, $file);



if($mode != "thumbnail" && $mode != "detail")
	if($Thumbnail_default)
		$mode = "thumbnail";
	else
		$mode = "detail";



function read_dir_tree($path){

	$dir = array();
	$h = @opendir($path); 
	while (($d = @readdir($h)) !== false){
		if (@is_dir($path."/".$d) && $d != "." && $d != ".." && ! eregi("^\.", $d)){
			$dir[] = $path."/".$d;
			$dir = array_merge($dir, read_dir_tree($path."/".$d));
		}
	}

	@closedir($h); 

	if($dir)
		sort($dir);
	return $dir;
}


function read_dir_array($path){

	$dir = array();
	$h = @opendir($path); 

	while (($d = @readdir($h)) !== false) 
		if (@is_dir($path."/".$d) && $d != "." && $d != ".." && ! eregi("^\.", $d))
			$dir[] =array(	"name" => $d,
									"type" => filetype($path."/".$d),
									"perms" => fileperms($path."/".$d),
									"mtime" => filemtime($path."/".$d),
								);

	@closedir($h); 

	if($dir)
		sort($dir);
	return $dir;
}



function read_file_array($path){

	$file = array();
	$h = @opendir($path); 

	while (($f = @readdir($h)) !== false)	 
		if (@is_file($path."/".$f) && ! eregi("^\.", $f) && check_ext($f))
			$file[] =array(	"name" => $f,
									"type" => filetype($path."/".$f),
									"size" => filesize($path."/".$f),
									"imgsize" => _getimagesize($path."/".$f),
									"perms" => fileperms($path."/".$f),
									"mtime" => filemtime($path."/".$f),
								);

	@closedir($h); 

	if($file)
		sort($file);
	return $file;
}


function print_href($path, $file, $DownloadImage, $width=false, $height=false){
	global $PHP_SELF;

	if($DownloadImage)	//-- ٿε ũ
		return "<a href='./lib.php?path=".rawurlencode($path)."&file=".rawurlencode($file)."&operate=down'>";
	else							//-- ̸ ũ
		return "<a href='#' onclick=\"View('./lib.php?operate=view&path=".rawurlencode($path)."&file=".rawurlencode($file)."','".$width."','".$height."')\" onfocus=\"blur()\">";

}


function type_img($ext = false){

	if(!$ext || !file_exists("./img/".$ext.".gif"))
		return "non.gif";
	else
		return $ext.".gif";
}


function allow_ext(){
	return array("jpg", "gif", "jpeg", "png");
}


function check_ext($val){
	return in_array(get_ext($val), allow_ext());
}


function get_ext($val){
	return strtolower(substr(strrchr($val,'.'),1));
}


function headerType($ext){
	switch($ext){
		case "gif":
			return "image/gif";
		case "jpg":
			return "image/jpeg";
		case "jpeg":
			return "image/jpeg";
		case "png":
			return "image/png";
		case "swf":
			return "application/x-shockwave-flash";
		case "avi":
			return "video/x-msvideo";
		case "asf":
			return "video/x-msvideo";
		case "mpg":
			return "video/mpeg";
		case "mpeg":
			return "video/mpeg";
		case "txt":
			return "text/plain";
		case "zip":
			return "application/x-zip-compressed";
		default :
			return "file/unknown";
	}
/*
	$header = array(
					'gif' => 'image/gif',
					'jpg' => 'image/jpeg',
					'jpeg' => 'image/jpeg',
					'png' => 'image/png',
					'swf' => 'application/x-shockwave-flash',
				);
	return $header[$ext];
*/
}


function display_perms( $m ){ 
	if( $m & 0x1000 ) $type='p';
	elseif( $m & 0x2000 ) $type='c';
	else if( $m & 0x4000 ) $type='d';
	else if( $m & 0x6000 ) $type='b';
	else if( $m & 0x8000 ) $type='-';
	else if( $m & 0xA000 ) $type='l';
	else if( $m & 0xC000 ) $type='s';
	else 	$type='u';

	$owner["read"] = ($m & 00400) ? 'r' : '-'; 
	$owner["write"] = ($m & 00200) ? 'w' : '-'; 
	$owner["execute"] = ($m & 00100) ? 'x' : '-'; 
	$group["read"] = ($m & 00040) ? 'r' : '-'; 
	$group["write"] = ($m & 00020) ? 'w' : '-'; 
	$group["execute"] = ($m & 00010) ? 'x' : '-'; 
	$world["read"] = ($m & 00004) ? 'r' : '-'; 
	$world["write"] = ($m & 00002) ? 'w' : '-'; 
	$world["execute"] = ($m & 00001) ? 'x' : '-'; 

	if( $m & 0x800 ) $owner["execute"] = ($owner[execute]=='x') ? 's' : 'S'; 
	if( $m & 0x400 ) $group["execute"] = ($group[execute]=='x') ? 's' : 'S'; 
	if( $m & 0x200 ) $world["execute"] = ($world[execute]=='x') ? 't' : 'T'; 

	printf("%1s", $type); 
	printf("%1s%1s%1s", $owner[read], $owner[write], $owner[execute]); 
	printf("%1s%1s%1s", $group[read], $group[write], $group[execute]); 
	printf("%1s%1s%1s\n", $world[read], $world[write], $world[execute]); 
}


function downFile($path, $file){
	global $root_path;

	$file_path = $root_path.$path."/".$file;
 
	if(!is_file($file_path) || !check_ext($file)) error(" ΰ ƴϰų ̿   ȮԴϴ.");

	if(substr_count($HTTP_USER_AGENT, "MSIE 5.5")) { 
		header("Content-Type: doesn/matter"); 
		header("Content-Disposition: filename=".$file); 
		Header("Content-Length: ".filesize($file_path)); 
		header("Content-Transfer-Encoding: binary"); 
	} 
	else {
		Header("Content-Type: application/octet-stream"); 
		Header("Content-Disposition: attachment; filename=".$file); 
		Header("Content-Length: ".filesize($file_path)); 
	}
	readfile($file_path);
	
	exit;
}


function viewFile($path, $file){
//	$filesize = _filesize(filesize($AB_PATH."photos/".$readDir."/".$name));
//	$filemtime = date("Y/m/d h:i:s", filemtime($AB_PATH."photos/".$readDir."/".$name));
?>
<html>
<head>
<title><?=$file?></title>
<meta http-equiv=Content-Type content=text/html; charset=EUC-KR>
<body topmargin='0'  leftmargin='0' marginwidth='0' marginheight='0' onload='self.focus()'>
<A href=# onclick="window.close()"><img src="./lib.php?operate=photo&path=<?=$path?>&file=<?=$file?>" border=0></a>
</body>
</head>
</html>
<?
exit;
}

function viewPhoto($path, $file){
	global $root_path, $myDomain, $img_path;

	if($myDomain){
		$url_info = parse_url($_SERVER["HTTP_REFERER"]);
		if(!in_array($url_info["host"], $myDomain))
			exit;
	}

	$src = $root_path . $path . "/" . $file;

	if(!is_file($src))
		 error("ش ο   ʽϴ.");
	



	$header = headerType(get_ext($file));
	if(!substr_count($HTTP_USER_AGENT, "MSIE 5.5"))
		$attachment = "attachment; ";

	Header("Content-Type: ".$header);
	Header("Content-Disposition: ".$attachment."filename=".$file); 

	@readfile($src);

//	$fp = fread(fopen($src, "r"), filesize($src));
//	echo $fp;

exit;
}


function _getimagesize($val){	//-- Return .. w ʺ, h , _w ˼ҳʺ, _h ҳ
	global $IMAGE_SIZE;

	$img = @getImageSize($val);
	

	if($IMAGE_SIZE > $img[0] && $IMAGE_SIZE > $img[1])
		return array("_w"=>$img[0], "_h"=>$img[1], "w"=>$img[0], "h"=>$img[1]);


	if($img[0] > $img[1]){
		$_temp = $img[0]/$IMAGE_SIZE;
		$small_value = floor($img[1]/$_temp);

		return array("_w"=>$IMAGE_SIZE, "_h"=>$small_value, "w"=>$img[0], "h"=>$img[1]);

	} else {
		$_temp = $img[1]/$IMAGE_SIZE;
		$small_value = floor($img[0]/$_temp);

		return array("_w"=>$small_value, "_h"=>$IMAGE_SIZE, "w"=>$img[0], "h"=>$img[1]);
	}

}





function getmicrotime() {
   	$microtimestmp = split(" ",microtime());
   	return $microtimestmp[0]+$microtimestmp[1];
}

function error($alert=false) {
	?><meta http-equiv="content-type" content="text/html; charset=euc-kr">
	   <script language="javascript">

	<? if($alert) { ?>
		window.alert("<?=$alert?>");
	<? } ?>
	    history.back();
	   </script>
	<? 
	exit;
}
















function head() {
?>
<!-----------------------------------------------------------
#
#	rose2her Photo Explorer(Ž)	Ver 0.9
#
#			: rose2her ()
#	Ȩ	: http://www.rose2her.com
#	Copyright	: Copyright  2003 rose2her All rights reserved.
#
#
#	 α׷  ۱     Ǹ  rose2her ֽϴ.
#
#	۱ ǥϰ    Ѿ   ,  뵵δ   ϴ.
#
#	 ҽ Ͽ Ҽ   α׷    ϴ.
#
#	 α׷   Ÿ ս  Ÿ ص    ؼ  rose2her  å  ʽϴ.
#
*----------------------------------------------------------->


<html>
<head>
<meta http-equiv='Content-Type' content='text/html; charset=euc-kr'>
<style type='text/css'>
<!--
A:link    {text-decoration: none;color:#333333}
A:visited {text-decoration: none;color:#333333}
A:active  {text-decoration: none;color:#666666}
A:hover   {text-decoration: none; color:#666666}

#body {
#			scrollbar-face-color:#F7F7F7; 
#			scrollbar-shadow-color:#cccccc ;
#			scrollbar-highlight-color: #FFFFFF;
#			scrollbar-3dlight-color: #FFFFFF;
#			scrollbar-darkshadow-color: #FFFFFF;
#			scrollbar-track-color: #FFFFFF;
#			scrollbar-arrow-color: #cccccc;
#}



BODY,TD,TR,DIV,form{font-size:9pt;color:#444444; font-family:,Tahoma,Verdana,MS Sans Serif,Courier New;}
.border_img {border:1 solid Gray;}
#.input {border:1; line-height:100%}
#.submit {font-size:9pt; font-family:; border-style:ridge; background-color:#f3f3f3; border-width:1pt; border-top-color:#ffffff; border-right-color:#eeeeee; border-bottom-color:#eeeeee; border-left-color:#ffffff;}
-->
</style>

<script language="javascript">

   function viewTree(str){
		tree = document.all['t'+str];
		img = document.all['i'+str];

			if (tree.style.display == 'none') {
				tree.style.display = 'inline';
				img.src = "./img/etc/m.gif";
			} else{
				tree.style.display = 'none';
				img.src = "./img/etc/p.gif";
			}
	}

	function View(url, width, height) {
	  window.open(url, 'rosePhoto', 'left=200,top=100,width='+width+',height='+height+',toolbar=no,menubar=no,status=no,scrollbars=no,resizable=no');
	}


</script>

</head>

<body>
<?
}


function foot() {
	global $_startTime;
?>
</body>
</html>


<!--
Excuted Time : <?=sprintf("%0.3f",getmicrotime()-$_startTime)?>

-->

<?
exit;
}

?>
